<template>
  <page>
    <a-collapse
      v-if="news.length > 0 && !fetching"
      v-model="activeKey"
    >
      <a-collapse-panel
        v-for="(item, i) in news"
        :key="`${i}`"
        :header="item.title"
      >
        <a-timeline>
          <!-- <a-timeline-item>
            <strong>Data da publicação: </strong>20 de Janeiro
          </a-timeline-item> -->
          <a-timeline-item>
            <strong>Descrição: </strong>{{ item.description }}
          </a-timeline-item>
          <a-timeline-item>
            <strong>Ações: </strong>
            <div class="actions">
              <a-popconfirm
                title="Tem certeza que deseja deletar?"
                ok-text="Sim. Quero deletar."
                cancel-text="Não"
                @confirm="deleteNews(item._id)"
              >
                <a-button
                  type="danger"
                  icon="delete"
                  :disabled="deleting"
                >
                  <span v-if="deleting">
                    <a-icon type="loading" />
                  </span>
                  <span v-else>Deletar</span>
                </a-button>
              </a-popconfirm>
            </div>
          </a-timeline-item>
        </a-timeline>
      </a-collapse-panel>
    </a-collapse>

    <no-data v-if="news.length === 0 && !fetching">
      Nenhuma notícia foi cadastrada no sistema
    </no-data>

    <page-loading v-if="fetching" />
  </page>
</template>

<script>
export default {
  name: 'News',
  data() {
    return {
      activeKey: ['0'],
      news: [],
      deleting: false,
      fetching: false,
    };
  },
  async created() {
    try {
      this.fetching = true;
      const fetch = await this.$http.get('/news');
      this.news = fetch.data;
      this.fetching = false;
    } catch (error) {
      this.fetching = false;
      this.$message.error('Ocorreu um erro ao tentar buscar as notícias. Tente novamente mais tarde.');
    }
  },
  methods: {
    async deleteNews(id) {
      try {
        this.deleting = true;
        await this.$http.delete(`/news/${id}`);
        this.updateNewsById(id);
        this.$message.success('Notícia deletada com sucesso');
        this.deleting = false;
      } catch (error) {
        this.deleting = false;
        this.$message.error('Ocorreu um erro ao deletar a notícia. Tente novamente mais tarde.');
      }
    },
    updateNewsById(id) {
      // eslint-disable-next-line no-underscore-dangle
      this.news = this.news.filter(news => news._id !== id);
    },
  },
};
</script>

<style lang="stylus" scoped>
.ant-timeline-item-last
  padding 0

.actions
  margin-top 1rem

  .ant-btn-primary
    margin-right 2rem
</style>
